------------------------------------------------------------------------------
--
-- Filename:                nand2.vhd
-- Inhalt:                  Zeitabhaengiges Modell eines NAND-Gatters 
--                          mit zwei Eingaengen, verwendet Typ "bit"
--
------------------------------------------------------------------------------
--
-- Autor:                   Gunther Lehmann
-- Letzte Aenderung:        07.03.1994
--
------------------------------------------------------------------------------

ENTITY nand2 IS

    GENERIC (tpd_lh: time := 230 ps; 
             tpd_hl: time := 170 ps);
    PORT (a,b: IN bit; y: OUT bit);

END nand2;

------------------------------------------------------------------------------

ARCHITECTURE number_one OF nand2 IS
    
BEGIN

    y <= '1' AFTER tpd_lh WHEN NOT (a AND b) = '1' ELSE
         '0' AFTER tpd_hl;

END number_one;

------------------------------------------------------------------------------

CONFIGURATION nand2_config OF nand2 IS

    FOR number_one
    END FOR;

END nand2_config;


