------------------------------------------------------------------------------
--
-- Filename:                rs_ff.vhd
-- Inhalt:                  strukturales Modell eines RS-Flip-Flops
--                          verwendet nand2.vhd (vorher uebersetzen)
--
------------------------------------------------------------------------------
--
-- Autor:                   Gunther Lehmann  
-- Letzte Aenderung:        18.01.1994
--
------------------------------------------------------------------------------

ENTITY rs_ff IS

   PORT (r_bar, s_bar : IN bit := '0';
         q, q_bar     : INOUT bit);

END rs_ff;


------------------------------------------------------------------------------

ARCHITECTURE structural OF rs_ff IS

   -- Komponentendeklaration -------------
   COMPONENT nand2_socket
      PORT (a, b : IN bit; y : OUT bit);
   END COMPONENT;

BEGIN

   -- Komponenteninstantiierung ----------
   nand_a : nand2_socket 
      PORT MAP (a => r_bar, b => q, y => q_bar);
   nand_b : nand2_socket 
      PORT MAP (a => q_bar, b => s_bar, y => q);

END structural;


------------------------------------------------------------------------------

CONFIGURATION rs_ff_config OF rs_ff IS

   FOR structural

      -- Komponentenkonfiguration --------
      FOR ALL : nand2_socket 
         USE ENTITY work.nand2 (number_one);
         -- verwendet Default-PORT MAP
         -- und Default-GENERIC MAP
      END FOR;

   END FOR;

END rs_ff_config;

