------------------------------------------------------------------------------
--
-- Filename:                types.vhd
-- Inhalt:                  Beispiel zu den physikalischen Typen:
--                          Deklaration eines internationalen Laengenmasses
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder 
-- Letzte Aenderung:        02.02.94
--
------------------------------------------------------------------------------

ENTITY types IS

  TYPE length IS RANGE -1E9 TO 1E9 --  -1000 bis +1000 km
    UNITS mm;
          cm = 10 mm;    -- nur ganzzahlige Vielfache
          dm = 10 cm;    -- als Multiplikatoren erlaubt
           m = 10 dm;
          km = 1E3 m;
        inch = 25 mm;    -- eigentlich: 25.399 mm
        foot = 305 mm;   -- eigentlich: 304.8 mm 
        mile = 16093 dm; -- Landmeile
   END UNITS;
    
END types;

------------------------------------------------------------------------------

ARCHITECTURE arch_1 OF types IS  -- Anwendung des Typen length

BEGIN

  PROCESS
    VARIABLE a,b,c,d : length ;
  BEGIN
    
    a := -2 m;          -- -2000 mm
    b := 1.6 cm;        -- 16 mm
    c := 1.66 cm;       -- 16 mm
    d := 1 mile + 4 cm + 2 mm + 3.2 inch + 7.01 foot; -- 1611560 mm
    WAIT;

  END PROCESS;

END arch_1 ;

