------------------------------------------------------------------------------
--
-- Filename:                not1.vhd
-- Inhalt:                  Zeitabhaengiges Modell eines Inverters, welches
--                          die 9-wertige Logik std_logic_1164 verwendet
--
------------------------------------------------------------------------------
--
-- Autor:                   Bernhard Wunder  
-- Letzte Aenderung:        18.01.1994
--
------------------------------------------------------------------------------

LIBRARY    ieee;
USE        ieee.std_logic_1164.all;

------------------------------------------------------------------------------

ENTITY not1 IS

    GENERIC (tp_lh: time := 140 ps; 
             tp_hl: time := 130 ps);
    PORT    (a: IN  std_ulogic;
             y: OUT std_ulogic);

END not1;

------------------------------------------------------------------------------

ARCHITECTURE behavioral OF not1 IS

-- Funktion zur Bestimmung des Minimums zweier Zeiten

    FUNCTION min (x, y: time) RETURN time IS
    BEGIN
        IF y < x THEN
            RETURN y;
        END IF;
        RETURN x;
    END min;

BEGIN

-- Berechnung des Ausgangs nach entsprechender Verzoegerung

    y <= '1' AFTER tp_lh WHEN ( NOT a = '1') ELSE
         '0' AFTER tp_hl WHEN ( NOT a = '0') ELSE
         'X' AFTER min (tp_lh,tp_hl);

END behavioral;

------------------------------------------------------------------------------

CONFIGURATION not1_config OF not1 IS

    FOR behavioral
    END FOR;

END not1_config;
